"use strict";
var categorization_directive_1 = require('../../../src/components/renderers/layouts/categories/categorization.directive');
var testers_1 = require('../../../src/components/renderers/testers');
var CategorizationExpandbarDirective = (function () {
    function CategorizationExpandbarDirective() {
        this.restrict = 'E';
        this.template = "\n    <jsonforms-layout>\n        <div class=\"row\">\n            <!-- Master -->\n            <div class=\"col-sm-30 jsf-masterdetail\">\n                <uib-accordion>\n                    <uib-accordion-group heading=\"{{categorization.label}}\"\n                        ng-repeat=\"categorization in vm.uiSchema.elements\">\n                        <div ng-repeat=\"category in categorization.elements\"\n                            ng-click=\"vm.changeSelectedCategory(category)\">\n                            <span ng-bind=\"category.label\" style=\"cursor:pointer\"></span>\n                        </div>\n                    </uib-accordion-group>\n                </uib-accordion>\n            </div>\n            <!-- Detail -->\n            <div class=\"col-sm-70\" >\n                <fieldset ng-if=\"vm.selectedCategory\">\n                    <jsonforms-inner ng-repeat=\"child in vm.selectedCategory.elements\"\n                        uischema=\"child\"></jsonforms-inner>\n                </fieldset>\n            </div>\n        </div>\n    </jsonforms-layout>\n    ";
        this.controller = categorization_directive_1.CategorizationController;
        this.controllerAs = 'vm';
    }
    return CategorizationExpandbarDirective;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = angular
    .module('jsonforms-bootstrap.renderers.layouts.categories.expandbar', ['jsonforms.renderers.layouts'])
    .directive('categorizationExpandbarElement', function () { return new CategorizationExpandbarDirective(); })
    .run(['RendererService', function (RendererService) {
        return RendererService.register('categorization-expandbar-element', testers_1.Testers.and(testers_1.uiTypeIs('Categorization'), testers_1.optionIs('expandbar', true)), 3);
    }
])
    .name;
//# sourceMappingURL=categorization-expandbar.directive.js.map